# Make a 2-core graph (delete degree 1 nodes and concatenate degree 2 nodes)
# Programmed by Mikio Kubo 
# Copyright supply chain optimization labo.  Shortest Path Project (2008)

from pylab import *
from networkx import *  # import networkx after pylab 
from dialmethodsub2 import *
filename="DC.tmp"
#filename="UT.tmp"
#filename="VA.tmp"
#filename="USA-road-d.NY"
G,n,m,C,size = ReadDimacs(filename)

degseq =G.degree()
dmax=max(degseq)+1
freq= [ 0 for d in xrange(dmax) ]
for d in degseq:
    freq[d] += 1

print "degree frequency histgram",freq

Node=set([])
Node1=set([])
for v in G.nodes_iter():
    if G.degree(v)==2:
        Node.add(v)
    elif G.degree(v)==1:
        Node1.add(v)

draw(G,G.position,node_size=1000/n,with_labels=None,width=1,node_color='b',edge_color='r')
print "Previous Graph=",G.info()

while 1:
    if Node==set([])and Node1==set([]): break
    #delete degree 1 nodes
    while 1:
        if Node1==set([]): break
        node1=Node1.pop()
        nei=G.neighbors(node1)
        if G.degree(node1)==1:
            G.delete_node(node1)
            if G.degree(nei[0])==2: Node.add(nei[0])
            if G.degree(nei[0])==1: Node1.add(nei[0])
        
    #concatenete degree 2 nodes
    while 1:
        if Node==set([]): break
        node=Node.pop()
        if G.degree(node)==2:
            nei=G.neighbors(node)
            shortcut=G.get_edge(nei[0],node)+G.get_edge(node,nei[1])
            if G.has_edge(nei[0],nei[1]):
                dis=G.get_edge(nei[0],nei[1])
                if dis<shortcut:
                    shortcut=dis #shorter length is stored
                G.delete_edge(nei[0],nei[1])
            #concatenate node
            G.delete_node(node)
            G.add_edge(nei[0],nei[1],shortcut)
            #add extreme points of the concatenate edge if their degree=2
            for i in range(2):
                if G.degree(nei[i])==2: Node.add(nei[i])
                if G.degree(nei[i])==1: Node1.add(nei[i])        

Node0=set([])
for v in G.nodes_iter():
    if G.degree(v)==0:
        Node0.add(v)

for v in Node0:
    G.delete_node(v)
        
degseq =G.degree()
dmax=max(degseq)+1
freq= [ 0 for d in xrange(dmax) ]
for d in degseq:
    freq[d] += 1

print "degree frequency histgram",freq

print "After Graph=",G.info()

Node=set([])
for v in G.nodes_iter():
    if G.degree(v)==1:
        Node.add(v)
draw(G,G.position,node_size=2,with_labels=None,width=3,node_color='b',edge_color='g')
#draw(G,G.position,nodelist=Node,node_size=10,with_labels=None,width=1,node_color='r',edge_color='b')
show()



